> This page is for version 2024-10-01 (default).
> For other versions, use one of these documentation indexes:
> - 2024-10-01 (default): https://docs.getkard.com/2024-10-01/llms.txt
> - Legacy: https://docs.getkard.com/legacy/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.getkard.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.getkard.com/_mcp/server.

# Create Subscription

POST https://rewards-api.getkard.com/v2/issuers/{organizationId}/subscriptions
Content-Type: application/json

Call this endpoint to subscribe to notification events.
Required scopes: `notifications:write`

Reference: https://docs.getkard.com/api/notifications/subscriptions/create

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://rewards-api.getkard.com` (Production, default)
- `https://test-rewards-api.getkard.com` (Sandbox)

## Request

### Path parameters

- `organizationId` (string, required) — Your issuer organization ID, provided by Kard

### Body (application/json)

This endpoint expects a SubscriptionRequestBody.

- `data` (list of SubscriptionRequestUnion, required)

## Response

### 201

- `data` (list of CreateSubscriptionUnion, required)

## Errors

### 401 Unauthorized Error

- `errors` (list of ErrorObject, required)

### 500 Internal Server Error

- `errors` (list of ErrorObject, required)

### 400 Invalid Request

- `errors` (list of ErrorObject, required)

### 409 Conflict Error

- `errors` (list of ErrorObject, required)

## Types

### SubscriptionRequestUnion

- `type`: `subscription`
  - `attributes` (SubscriptionRequestAttributes, required)

### CreateSubscriptionUnion

- `type`: `subscription`
  - `attributes` (SubscriptionRequestAttributes, required)
  - `id` (string, required) — The ID of the subscription

### ErrorObject

- `status` (string, required) — Status code returned from the request
- `title` (string, required) — Name of error
- `detail` (string, required) — Description of the specific occurance of the error
- `source` (ErrorSource, optional) — An object containing a reference to the primary source of the error
- `id` (string, optional) — The id of the resource which caused the error. Always returned for multi-status errors.

### SubscriptionRequestAttributes

- `eventName` (enum, required) — The name of the event for the subscription
  - Allowed values: `earnedRewardApproved`, `earnedRewardSettled`, `earnedRewardRejected`, `auditUpdate`, `fileProcessingResult`, `pushNotificationPlacementFile`, `emailNotificationPlacementFile`
- `webhookUrl` (string, required) — The URL where notifications will be delivered
- `enabled` (boolean, required) — Indicates whether the subscription is active

### ErrorSource

- `pointer` (string, optional) — A JSON pointer to the value in the request document that caused the error
- `parameter` (string, optional) — A string indicating which URI query parameter caused the error
- `header` (string, optional) — A string indicating the name of a single request header which caused the error

## Examples

**Request**

```json
{
  "data": [
    {
      "type": "subscription",
      "attributes": {
        "eventName": "earnedRewardApproved",
        "webhookUrl": "https://webhookUrl.com/post",
        "enabled": true
      }
    }
  ]
}
```

**Response**

```json
{
  "data": [
    {
      "type": "subscription",
      "attributes": {
        "eventName": "earnedRewardApproved",
        "webhookUrl": "https://webhookUrl.com/post",
        "enabled": true
      },
      "id": "0193i257-014e-7dd2-9455-fb964d9c85cr"
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://rewards-api.getkard.com/v2/issuers/organization-123/subscriptions"

payload = { "data": [
        {
            "type": "subscription",
            "attributes": {
                "eventName": "earnedRewardApproved",
                "webhookUrl": "https://webhookUrl.com/post",
                "enabled": True
            }
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://rewards-api.getkard.com/v2/issuers/organization-123/subscriptions';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"data":[{"type":"subscription","attributes":{"eventName":"earnedRewardApproved","webhookUrl":"https://webhookUrl.com/post","enabled":true}}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rewards-api.getkard.com/v2/issuers/organization-123/subscriptions"

	payload := strings.NewReader("{\n  \"data\": [\n    {\n      \"type\": \"subscription\",\n      \"attributes\": {\n        \"eventName\": \"earnedRewardApproved\",\n        \"webhookUrl\": \"https://webhookUrl.com/post\",\n        \"enabled\": true\n      }\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://rewards-api.getkard.com/v2/issuers/organization-123/subscriptions")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"data\": [\n    {\n      \"type\": \"subscription\",\n      \"attributes\": {\n        \"eventName\": \"earnedRewardApproved\",\n        \"webhookUrl\": \"https://webhookUrl.com/post\",\n        \"enabled\": true\n      }\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rewards-api.getkard.com/v2/issuers/organization-123/subscriptions")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"data\": [\n    {\n      \"type\": \"subscription\",\n      \"attributes\": {\n        \"eventName\": \"earnedRewardApproved\",\n        \"webhookUrl\": \"https://webhookUrl.com/post\",\n        \"enabled\": true\n      }\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rewards-api.getkard.com/v2/issuers/organization-123/subscriptions', [
  'body' => '{
  "data": [
    {
      "type": "subscription",
      "attributes": {
        "eventName": "earnedRewardApproved",
        "webhookUrl": "https://webhookUrl.com/post",
        "enabled": true
      }
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://rewards-api.getkard.com/v2/issuers/organization-123/subscriptions");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"data\": [\n    {\n      \"type\": \"subscription\",\n      \"attributes\": {\n        \"eventName\": \"earnedRewardApproved\",\n        \"webhookUrl\": \"https://webhookUrl.com/post\",\n        \"enabled\": true\n      }\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["data": [
    [
      "type": "subscription",
      "attributes": [
        "eventName": "earnedRewardApproved",
        "webhookUrl": "https://webhookUrl.com/post",
        "enabled": true
      ]
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rewards-api.getkard.com/v2/issuers/organization-123/subscriptions")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```